/************************************************************************
              WinControl Example Command "1"

              This is a part outof WinControl SDK package.
              Version History:
              v1.00 - 1999/09/03*
              v1.30 - 2000/01/24 - Major Update, first public release

              Last modifyed 2000/01/24
              (c)1999-2000 HALAN Innovations, all rights reserved
              Author: Daniel Halan (daniel@wincontrol.com)

**************************************************************************/

// #include <string.h>

#include <windows.h>
#include <kmdstd.h>
#include <winioctl.h>

#define DLLEXPORT extern "C" __declspec( dllexport )


char *KMD_NAME = "VC++ Example Command";

enum wExCmd {ecTest1,ecTest2,ecTest3};
struct wCmdData
{
	wExCmd	Command;
	HICON	ExIcon;
};


// Global command specific Values
wCmdData	*Data;
// Communication Var's
wMainText	*MainOpt;
wParam		*Params;
HINSTANCE	hInstance;
DLLEXPORT wCmdInfo __stdcall GetInfo(void)
{
	wCmdInfo info;
	info.Name		= KMD_NAME;
	info.Author		= "Daniel Halan";
	info.Company	= "(c)1999-2000 HALAN Innovations";
	info.VerInfo	= "Release";
	info.Desc		= "Example Command for the SDK";
	info.HelpFile	= "ExmpCmd.hlp";
	return info;
};

// example on an OnEvent Callback function
// This will be called every time the ItemIndex value
// of RadioGrp changes.
long __stdcall OnRadioProc (long Index)
{
	// Add an Event
	return Index;
};


DLLEXPORT wError __stdcall Main(/*wEventCall*/WORD Event, wMainValues *rMain)
{
	switch (Event)
	{
		case ecInitize: // Initize all Paramaters
		{
			AssignWinCon(rMain);
			
			// Add an Icon
			char *pc = NewPChar(NULL,255);
			GetModuleFileName(hInstance,pc,255);
			Data->ExIcon = ExtractIcon((HINSTANCE)wincon.WndHandle,pc,0);
			FreePChar(pc);


 			wVisible *Vis1,*Vis2;

			Params = NewParams(KMD_NAME,4,180,0,Data->ExIcon);
			
 			//Params = NewParams(KMD_NAME,5,180,0);
			
			// Radio Group
			char *Items[3] = {"Test 1","Test 2","Test 3"};
			Params->Values[0] = CreateRadioGroup("Actions:",3,Items,
			0,   // ItemIndex
			2,   // Help Context
			0,	 // Visible Object Count
			NULL,  // Array of *wVisible
			50,  // Prop. Width, 0-100%
			0,   // Prop. Left, 0-100%
			0,   // TopPos, 0 = TopMost...
			(Params->Height-FRAME_OFFSET), // Height in Pixels
			OnRadioProc);  // OnValueChange Callback (this can be skipped if you don't use any)
	
			// ComboBox, Showed when RadioGrp ItemIndex is 0
			Vis1 = new wVisible; Vis1->Item = 0; Vis1->ItemIndex = 0;
			wVisible *VisItems1[1] = { Vis1 };
			char *Items2[] = {"Something 1","Something 2"};
			Params->Values[1] = CreateComboBox("Options:",2,Items2,
			0,   // ItemIndex
			4,   // Help Context
			1,   // Visible Item (Parameter Index, has to be an RadioGroup or ComboBox)
			VisItems1,   // Visible ItemIndex (what Index should be active for thus control to be visible)
			50, // Prop. Width, 0-100%
			50,   // Prop. Left, 0-100%
			0);  // TopPos, 0 = TopMost...
	
			Vis1 = new wVisible; Vis1->Item = 0; Vis1->ItemIndex = 1;
			Vis2 = new wVisible; Vis2->Item = 0; Vis2->ItemIndex = 2;
			wVisible *VisItems2[2] = { Vis1,Vis2 };
			// Integer EditBox, Showed when RadioGrp ItemIndex is 1
			Params->Values[2] = CreateIntEdit("Test1 Integer:",129,65535,0,4,2,VisItems2,50,50,0);

			Vis1 = new wVisible; Vis1->Item = 0; Vis1->ItemIndex = 1;
			VisItems1[0] = Vis1;
			// EditBox, Showed when RadioGrp ItemIndex is 2
			Params->Values[3] = CreateEdit("Test2 String:",NULL,eNone,NULL,255,0,1,VisItems1,50,50,1);			
			
			break;
		};
		case ecDispose: // Free all Parameters
		{
			return FreeParams(Params);			
			break;
		};
		default:
			return ERR_UNKNOWN_ORDER; 
	};
	return ERR_NOPROBLEM;
};

DLLEXPORT wParam * __stdcall GetParams(void)
{
  return Params;
};

DLLEXPORT wMainText* __stdcall GetMainViewText(WORD Order, wParam *Prm)
{
	// Cast Order to wOrder
	// oThis = Current Param Value
	// oNext = Next Param Value
	// oPrev = Prev Param Value
	// ...
	// Order is used when the SetupWindow-Edit Box is ReadOnly, and the
	// User Presses Arrow keys Up/Down to browse thru the Options.

	// Static EditBox
	Data->Command = wExCmd(((wParamValue*)Prm->Values[0])->Value); // The RadioGroup, ItemIndex
	/*
	GetPrmValue(Prm->Values[1]) = ItemIndex of ComboBox
	GetPrmValue(Prm->Values[2]) = Value of IntEdit
	((wParamValue*)Prm->Values[3])->Value = char* of Edit. use NewPChar() / FreePChar() for manipulation
	and so on...
	*/
	char *TestChr = NewPChar("My PChar Test",0 /* Length is used when if Str is NULL */);
	FreePChar(TestChr);

  // Values
  //===========
  // For using the Longint value of a Param, use the XXXPrmValue() functions
  // SetPrmValue(Prm.Values[0],1);
  // GetPrmValue(Prm.Values[0]) = Value
  // CmpPrmValue(Prm.Values[0],1);
  // IncPrmValue(Prm.Values[0]);
  // DecPrmValue(Prm.Values[0]);
  // if the param is wEdit (Value is String) then Assign the Value directly
  // by Casting the PChar to LongWord. Example:
  // Prm->Values[0]->Value = ((DWORD)NewPChar("Hello"));
  // Always Remeber, If you want to overwrite an existing Str, Free it First! (FreePChar(x))

	
	MainOpt->Icon = Data->ExIcon; // Windows Icon Handle
	switch (Data->Command)
	{
		case ecTest1: MainOpt->Text = "Example: Some Info"; break;
		case ecTest2: MainOpt->Text = "Example: I Do Something..."; break;
		case ecTest3: MainOpt->Text = "Example: I really Want to do something"; break;
	};
  // or Add the Text written in the TextBox
  // MainOpt.Text = PChar(pParamValue(Prm.Values[3]).Value);

  return MainOpt;
};



DLLEXPORT wMainText * __stdcall SetMainViewText(wParam *Prm, char *Str)
{
	// Here you can Change / Approve the user change of Text, and set The Icon

	// you can modify the New "Str" that the User edits in the SetupWindow.
	// use "NewPChar()" and "FreePChar()" for String Allocation/Disposing
	// use "NewArr(Count)" and "DispArr(Ptr)" to Allocate/Dispose Ptr Arrays, ie char* Array..
	
  return GetMainViewText(0,Prm);
};

// Calls when the Command is Trigged
DLLEXPORT wError __stdcall Execute(wParam *Prm)
{
  Data->Command = wExCmd( ((wParamValue*)Prm->Values[0])->Value);
  
  switch (Data->Command)
  {
	case ecTest1:
		{	
			// Do stuff..
			break;
		};
	case ecTest2:
		{
			// Do other stuff
			break;
		};
    case ecTest3:
        {
			// Do fun stuff...
			break;
		};
  };
  return ERR_NOPROBLEM;
};

// DLL init/cleaup code goes here 
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  switch(fdwReason)
  {
	case DLL_PROCESS_ATTACH: // initize Command specific Values
		{
			hInstance = hinstDLL;
			MainOpt = new wMainText;
			MainOpt->Text = NULL;
			MainOpt->Icon = 0;
			MainOpt->ReadOnly = TRUE;

			Data = new wCmdData;
			Data->Command = ecTest1; 
			    
			break;
		};
    case DLL_PROCESS_DETACH: // cleanup
		{
			delete MainOpt;
			delete Data;
			break;
		};
  };
  return TRUE;
};